<?php
/**
 * Documents the file following
 * @package GMAPI-wordpress
 * @author webcat
 */
//#################################################################
if (preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) {
    die('You are not allowed to call this page directly.');
}
//#################################################################
if (!class_exists('GMAPI')) {

    /**
     * Factory class for getting the required googlemaps api objects at runtime
     * @link http://davidwalsh.name/dynamic-functions
     * Lovely explanation
     * All object methods return null if they dont exist or the package is not supported
     * All calls to unsupported classes return a Zombie
     * Any method that doesnt exist will return null
     * Use: Create an instance of GMAPI, create instances of API objects by getting a package (getPackagename('classname'))<br />
     * Supported methods are provided for
     *
     */
    class GMAPI {
        /**
         *
         * @var array of file names in the package 
         */
        protected static $names=array();
        public static function newName($type){
            $rnd=$type.mktime();
            while(in_array($rnd, GMAPI::$names)){
            $rnd=$type.mktime();
            }
            array_push(GMAPI::$names, $rnd);
            return $rnd;
        }
        private $domain;
        public $profiler;
        public $debugMode=false;
        function __construct($domain) {
            require_once 'C:\xampp\htdocs\PQP\classes\PhpQuickProfiler.php';
            $this->profiler = new PhpQuickProfiler(PhpQuickProfiler::getMicroTime());
            Console::logSpeed("Enter GMAPI");
            //Console::log($this->objects);
            //Console::log(GMAPI::$args);
            $this->domain=$domain;
        }
       public function __destruct() {
        if($this->debugMode == true) $this->profiler->display($this->db);
    }
       public function getMap($temp){
           $map = new GMAPIMap();
           return $this->register($map);
       }
       function register($class){
           //GMAPI::$names[GMAPI::newName('map')]=$map;
            //Console::logSpeed("Register name: ".$name." and factory ".$factory);
            Console::log($class);
            return $class;
        }
    }
    class GMAPIgoogleclass {
        public static $eventsArray=array();
        public static $propertiesArray=array();
        public static $methodsArray=array();
        protected $googleProps=array();
        protected $googleEvents=array();
        protected $googleMethods=array();
        protected $setup=false;
        protected $name;
        protected $factory;
        function __construct(){
            $this->name=GMAPI::newName(get_class($this));
            }
        function register($f){
            $this->factory=$f;
        }
        function init(){
        }
        public function script(){}
        public function __call($name,$args){
            if(function_exists($name)){
                $this->$name($args);
                //$this->googleProps[$name]=$value;
            }else{
                throw new Exception("Cannot call undefined methods".get_class($this),1);
            }
        }
        public function __set($name, $value) {
            if(!empty($this->googleProps) && array_key_exists($name, $this->googleProps)){
                $this->googleProps[$name]=$value;
            }else{
                throw new Exception("Cannot assign values to undefined variables".get_class($this),1);
            }
        }
        public function  __get($name) {
            if($name=='name'){return $this->name;}
            if($name=='factory'){return $this->factory;}
            if(!empty($this->googleProps) && array_key_exists($name, $this->googleProps) && $this->setup){
                return $this->googleProps[$name];
            }else{
                throw new Exception("Cannot retrieve values to undefined variables".$name." + ".get_class($this),1);
            }
        }
    }
    class MVCObject extends GMAPIgoogleclass{
        public static $eventsArray=array();
        public static $methodsArray=array();
        public static $propertiesArray=array();
        protected $googleProps=array();
        protected $googleEvents=array();
        protected $googleMethods=array();

        function __construct(){
            parent::__construct();
            $this->setup=true;
        }
        function init(){}
        function script(){}
    }
    class LatLng extends GMAPIgoogleclass  {
        public static $eventsArray=array();
        public static $methodsArray=array('equals','lat','long','toString');
        public static $propertiesArray=array('lat','long');
        protected $googleProps=array('lat'=>'0','long'=>'0');
        protected $googleEvents=array();
        protected $googleMethods=array();
        function __construct($lat='0',$long='0'){
            parent::__construct();
            $this->init($lat,$long);
        }
        function init($lat,$long){
            $this->googleProps['lat']=$lat;
            $this->googleProps['long']=$long;
            $this->setup=true;
        }
        function script(){
            $script="var ".$this->name." = new google.maps.LatLng(".$this->toString().");";
            return $script;
        }
        function toString(){
            return "'".$this->googleProps['lat']."','".$this->googleProps['long']."'";
        }
    }
    class GMAPIMap extends MVCObject {
        public static $methodsArray=array('setOptions','setCenter','setZoom');//implemented
        public static $propertiesArray=array('mapTypes'=>array());//implemented
        protected $googleProps=array('options'=>null,'center'=>null,'zoom'=>1,'div'=>'','width'=>0,'height'=>0);
        protected $Bounds;protected $Projection;protected $StreetView;protected $Tilt;protected $Heading;protected $Options;
        function __construct($width=350,$height=350,$lat='',$long='',$zoom=1,$type='ROADMAP'){
            parent::__construct();
            $this->init( $width, $height, $lat, $long, $zoom, $type);
        }
        function init($width, $height, $lat, $long, $zoom, $type){
            $this->googleProps['center']=new LatLng($lat, $long);
            $this->googleProps['options']=new MapOptions($this->googleProps['center'],new MapTypeId($type),$zoom);
            $this->googleProps['width']=$width;
            $this->googleProps['height']=$height;
            $this->setup=true;
        }
        function scriptHead(){
            $script="";
            $script.="<script type=\"text/javascript\" >";
            $script.="document.write('<div class=\"map\" id=\"".$this->name."\" style=\"width:".$this->googleProps['width']."px;height:".$this->googleProps['height']."px;\"></div>');";
            $script.="window.onload(init".$this->name."());";
            $script.="function init".$this->name."(){
                        var ".$this->googleProps['center']->name." = new google.maps.LatLng('".$this->googleProps['center']->lat."','".$this->googleProps['center']->long."');
                        var ".$this->googleProps['options']->name." = {
                          zoom: ".$this->googleProps['options']->zoom.",
                          center: ".$this->googleProps['center']->name.",
                          mapTypeId: google.maps.MapTypeId.".$this->googleProps['options']->mapTypeId->getType()."
                        };";
            $script.="var ".$this->name." = new google.maps.Map(document.getElementById('".$this->name."'),".$this->googleProps['options']->name.");";
            return $script;
        }
        function scriptFoot(){
            return "}</script>";
        }
        function addMarkers($es){}
        function addFeatures(){}
        function script($markersArray=array()){
            $script=$this->scriptHead();
            if(is_array($markersArray)&& sizeof($markersArray)>=1){
                foreach($markersArray as $key=>$marker){
                    $options=new GMAPIMarkerOptions(new LatLng($marker['lat'],$marker['long']),$this->name,$marker['title'],true);
                    $nmarker=new GMAPIMarker($options);
                    $script.=$nmarker->script();
                    if(!$marker['note']==''){
                    $infooptions=array('content'=> htmlspecialchars_decode($marker['note']));
                    $info = new GMAPIInfoWindow($infooptions);
                    $script.=$info->script();
                    $event= new GMAPIEvent(''.$nmarker->name,'click','function()',$info->name.'.open('.$this->name.','.''.$nmarker->name.');');
                    $script.=$event->script();
                    }
                    $marker=null;
                }
            }
            if(!empty ($eventsArray)&& !is_null($eventsArray)){
                foreach($eventsArray as $event){
                    $script.="map".$this->name.".".$event->script();
                }
            }
            //$script.="window.alert(".$this->googleProps['div'].".getCenter());";
            $script.=$this->scriptFoot();
            return $script;
        }
    }
    class MapOptions extends GMAPIgoogleclass {
        public static $eventsArray=array();
        public static $methodsArray=array();
        public static $propertiesArray=array('center','mapTypeId','zoom');
        protected $googleProps=array('center'=> null,'mapTypeId'=>null,'zoom'=>1);
        protected $googleEvents=array();
        protected $googleMethods=array();
        //public static $propertiesArray=array('backgroundColor', 'center', 'disableDefaultUI', 'disableDoubleClickZoom', 'draggable', 'draggableCursor', 'draggingCursor', 'heading', 'keyboardShortcuts', 'mapTypeControl', 'mapTypeControlOptions', 'mapTypeId', 'maxZoom', 'minZoom', 'noClear', 'overviewMapControl', 'overviewMapControlOptions', 'panControl', 'panControlOptions', 'rotateControl', 'rotateControlOptions', 'scaleControl', 'scaleControlOptions', 'scrollwheel', 'streetView', 'streetViewControl', 'streetViewControlOptions', 'styles', 'tilt', 'zoom', 'zoomControl', 'zoomControlOptions');

        //private $mapOptionsArray = new array[31];//
/**
 * Creates a mapoptions object
 */
        function __construct($center=null,$id=null,$zoom=1){
            parent::__construct();
            $this->init($center,$id,$zoom);
        }
        function init($center,$id,$zoom){
            parent::__construct('mapoptions');
            $this->googleProps['center']=$center;
            $this->googleProps['zoom']=$zoom;
            $this->googleProps['mapTypeId']=$id;
            $this->setup=true;
        }
/**
 * returns a string of js to be used with a map object
 */
        function compileMapOptions(){
            $script="{";
            $script.="zoom:".$this->zoom;
            $script.="center:".$this->center;//$googleProps['center']->getLatlng();
            $script.="mapTypeId:".$this->mapTypeId;//$googleProps['mapTypeId']->getType();;
            $script.="}";
        }
        function script($name=""){
            return "Skeleton function";
        }
    }
    class MapTypeId {
        protected $MapTypeIdarray=array('type'=>'ROADMAP');
        private $id;
        function __construct($id){
            $this->id=strtoupper($id);
        }
        function getType(){
            return $this->id;
        }
    }
    class GMAPIMarker extends GMAPIgoogleclass {
        public static $eventsArray=array();
        public static $methodsArray=array();
        public static $propertiesArray=array('markerOptions');
        protected $googleProps=array('markerOptions'=> null);
        protected $googleEvents=array();
        protected $googleMethods=array();

        function __construct($markerOptions){
            parent::__construct();
            $this->init($markerOptions);
        }
        function init($mO){
            $this->googleProps['markerOptions']=$mO;
            $this->setup=true;
        }
        function script(){
            $script=  $this->googleProps['markerOptions']->position->script($name.$key);
            $script.="var ".$this->name." = new google.maps.Marker({";
            $script.="position:".$this->googleProps['markerOptions']->position->name.",";
            $script.="map: ".$this->googleProps['markerOptions']->map.",";
            $script.="title:\"".$this->googleProps['markerOptions']->title."\"}); ";
            return $script;
        }
    }
    class GMAPIMarkerOptions extends GMAPIgoogleclass {
        public static $eventsArray=array();
        public static $methodsArray=array();
        public static $propertiesArray=array('animation','clickable','cursor','draggable','flat','icon','map','optimized','position','raiseOnDrag','shadow','shape','title','visible','zIndex' );
        protected $googleProps=array('position'=> null,'map'=>"",'title'=>"",'clickable'=>true);
        protected $googleEvents=array();
        protected $googleMethods=array();

        function __construct($position=null,$map="",$title="",$clickable=true){
            parent::__construct();
            $this->init($position,$map,$title,$clickable);
        }
        function init($position,$map,$title,$clickable){
            $this->googleProps['position']=$position;
            $this->googleProps['map']=$map;
            $this->googleProps['title']=$title;
            $this->googleProps['clickable']=$clickable;
            $this->setup=true;
        }
        function script(){
            return $name;
        }
    }
    class GMAPIInfoWindow extends GMAPIgoogleclass {
        //public static
        public static $eventsArray=array('closeclick','content_changed','domready','position_changed','zindex_changed');
        public static $methodsArray=array('close','getContent','getPosition','getZIndex','open','setContent','setOptions','setPosition','setZIndex');
        public static $propertiesArray=array('animation','clickable','cursor','draggable','flat','icon','map','optimized','position','raiseOnDrag','shadow','shape','title','visible','zIndex' );
        protected $googleProps=array('options'=> array());
        protected $googleEvents=array();
        protected $googleMethods=array('open','setOptions');
        function __construct($options=array()){
            parent::__construct();
            $this->init($options);
        }
        function init($options){
            $this->options=$options;
        }
        function script(){
            $script="";
            $script.="var ".$this->name." = new google.maps.InfoWindow({content: ";
            $script.= "'".$this->googleProps['options']['content'];
            $script.="'});";
            return $script;
        }
    }
    class GMAPIInfoWindowOptions extends GMAPIgoogleclass {
        //public static
        public static $propertiesArray=array('content','disableAutoPan','maxWidth','pixelOffset','position','zIndex' );
        protected $googleProps=array('content','disableAutoPan','maxWidth','pixelOffset','position','zIndex');

        function __construct($content='',$disableAutoPan=false,$maxWidth=0,$pixelOffset=0,$position=null,$zIndex=1000){
            parent::__construct();
            $this->init($content,$disableAutoPan,$maxWidth,$pixelOffset,$position,$zIndex);
        }
        function init($content='',$disableAutoPan=true,$maxWidth=350,$pixelOffset=0,$position=null,$zIndex=1000){
            $this->googleProps['content']=$content;
            $this->googleProps['disableAutoPan']=$disableAutoPan;
            $this->googleProps['maxWidth']=$maxWidth;
            $this->googleProps['pixelOffset']=$pixelOffset;
            $this->googleProps['position']=$position;
            $this->googleProps['zIndex']=$zIndex;
        }
        function script(){
            $script="";
            $script.="content:".$this->googleProps['content'];
            if(!$this->googleProps['disableAutoPan']){$script.=",disableAtoPan:".$this->googleProps['disableAutoPan'];}
            if(!$this->googleProps['maxWidth']>0){$script.=",maxWidth:".$this->googleProps['maxWidth'];}
            if(!$this->googleProps['pixelOffset']>0){$script.=",pixelOffset:".$this->googleProps['pixelOffset'];}
            if(!$this->googleProps['position']==null){$script.=",position:".$this->googleProps['position']->getName();}
            if(!$this->googleProps['maxWidth']>0){$script.=",maxWidth:".$this->googleProps['maxWidth'];}

            return $script;
        }
    }
    class GMAPIEvent extends GMAPIgoogleclass {
        public static $methodsArray=array('addDomListener','addDomListenerOnce','addListener','addListenerOnce','clearInstanceListeners','clearListeners','removeListener','trigger');
        protected $googleMethods=array('addListener');
        public static $eventParams=array();
        protected $googleProps=array('objectname'=>'','trigger'=>'click','functionname'=>'','functionargs'=>'');
        function __construct($objectname='',$trigger='click',$functionname='',$functionargs=''){
            parent::__construct();
            $this->init($objectname,$trigger,$functionname,$functionargs);
        }
        function init($objectname='',$trigger='click',$functionname='',$functionargs=''){
            $this->googleProps['objectname']=$objectname;
            $this->googleProps['trigger']=$trigger;
            $this->googleProps['functionname']=$functionname;
            $this->googleProps['functionargs']=$functionargs;
        }
        function script(){
            $script="google.maps.event.addListener(";
            $script.=$this->googleProps['objectname'].",'". $this->googleProps['trigger']."',".$this->googleProps['functionname'];
            $script.="{".$this->googleProps['functionargs']."});";
            return $script;
        }
    }
}
?>