<?php
/**
 * Documents the file following
 * @package googlemapsForWP
 * @author webcat
 */
//#################################################################
if(preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) { die('You are not allowed to call this page directly.'); }
//#################################################################
if (!class_exists('googlemapsForWPMapImage')){
/**
 * googlemapsForWP maps
 * The class provides access to
 */
	 class googlemapsForWPMapImage {
             protected $pathtocache;
             protected $hascurl;
            
/**
 *
 * @param <type> $id
 * @param <type> $args
 */
            function __construct(){
                $this->pathtocache=googlemapsForWP::pluginDir() .'cache'. DIRECTORY_SEPARATOR;
                $ch = curl_init();
                if(!$ch){
                    $this->hascurl= false;
                }else{
                    $this->hascurl= true;
                }
            }
            function checkCache(){}
            function deleteAllMaps(){
                try{
                    $folder=opendir($this->pathtocache);
                    if($folder){
                        while (($file = readdir($folder)) !== false) {
                            if(stripos($file, 'map-')===0){
                                unlink($this->pathtocache.$file);
                            }
                        }
                        closedir($folder);
                    }
                }catch(Exception $e){}
            }
/**
 * stores map images according to their extension <br/>Tries to use cUrl or reading in from remote file directly
 * @uses cUrl
 * or
 * @uses allow_url_fopen
 * @link http://www.edmondscommerce.co.uk/php/php-save-images-using-curl/
 * @param googlemapsForWPMap $aMap
 * @return void
 */
            function storeImage($aMap){
                if(is_a($aMap,googlemapsForWPMap)){
                    $ext=$aMap->getExt($aMap->getParam('format'));
                    $fullpath=$this->pathtocache.'map-'.$aMap->getID().'.'.$ext;
                    if($this->hascurl){
                        $ch = curl_init();
                        $timeout = 0;
                        curl_setopt ($ch, CURLOPT_URL, $aMap->createURL(1));
                        curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                        curl_setopt($ch, CURLOPT_BINARYTRANSFER, 1);
                        $image = curl_exec($ch);
                        curl_close($ch);
                        try {
                            if(file_exists($fullpath)){
                                unlink($fullpath);
                            }
                                $fp = fopen($fullpath,'x');
                                fwrite($fp, $image);
                                fclose($fp);
                        }catch(Exception $e){
                            return;
                        }
                    }else{
                        try{
                          $googlemap = $aMap->createURL('1');
                          switch ($ext) {
                              case 'jpg':
                                $img = imagecreatefromjpeg($googlemap);
                                imagejpeg($img, $fullpath);
                                break;
                              case 'png':
                                $img = imagecreatefrompng($googlemap);
                                imagepng($img, $fullpath);
                                break;
                              case 'gif':
                                $img = imagecreatefromgif($googlemap);
                                imagegif($img, $fullpath);
                                break;
                              default:
                                $img = imagecreatefrompng($googlemap);
                                imagepng($img, $fullpath);
                                break;
                          }
                        }catch(Exception $e){}
                    }
                }
            }
/**
 * Deletes maps from cache
 * @usedby googlemapsForWPAdmin when delete map from db
 * @param string $mapid
 */
            function deleteImage($mapid){
                $fullpath=$this->pathtocache.'map-'.$mapid;
                    try {
                        if(file_exists($fullpath.'.png')){
                            unlink($fullpath.'.png');
                        }
                        if(file_exists($fullpath.'.jpg')){
                            unlink($fullpath.'.jpg');
                        }
                        if(file_exists($fullpath.'.gif')){
                            unlink($fullpath.'.gif');
                        }
                    }catch(Exception $e){}
            }

    }
}

?>