<?php
/**
 * Documents the file following
 * @package GMAPI
 * @author webcat
 */
//#################################################################
if (preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) {
die('You are not allowed to call this page directly.');
}
//#################################################################

if (!class_exists('GMAPIMap')) {
/**
 * googlemapsForWP maps
 * Maps database data to map classes
 */
class GMAPIMap extends GMAPIFactory {

      public static $classesArr =array('Map','MapOptions', 'MapTypeId');
        function __construct(){
            parent::__construct();
        }
    }
}
if (!class_exists('Map')) {
/**
 *
 */
    class Map extends MVCObject implements googleclass {
        //public static $eventsArray=array('bounds_changed','center_changed','click','dblclick','drag','dragend','dragstart','heading_changed','idle','maptypeid_changed','mousemove','mouseout','mouseover','projection_changed','resize','rightclick','tilesloaded','tilt_changed','zoom_changed');
        public static $eventsArray=array();//implemented
        //public static $methodsArray=array('fitBounds','getBounds','getCenter','getDiv','getHeading','getMapTypeId','getProjection','getStreetView','getTilt','getZoom','panBy','panTo','panToBounds','setCenter','setHeading','setMapTypeId','setOptions','setStreetView','setTilt','setZoom');
        public static $methodsArray=array('setOptions','setCenter','setZoom');//implemented
        //public static $propertiesArray=array('controls','overlayMapTypes');
        public static $propertiesArray=array('mapTypes'=>array());//implemented
        protected $googleProps=array('options'=>null,'center'=>null,'zoom'=>1,'div'=>'','width'=>0,'height'=>0);
        protected $googleEvents=array();
        protected $googleMethods=array();
        protected $Bounds;protected $Projection;protected $StreetView;protected $Tilt;protected $Heading;protected $Options;
        function __construct($div='',$width=350,$height=350,$lat='',$long='',$zoom=1,$type='ROADMAP'){
            $this->init($div, $width, $height, $lat, $long, $zoom, $type);
        }
        function init($div, $width, $height, $lat, $long, $zoom, $type){
            GMAPI::getFile('GMAPI-base.php');
            $this->googleProps['center']=new LatLng($lat, $long);
            $this->googleProps['options']=new MapOptions($this->googleProps['center'],new MapTypeId($type),$zoom);
            $this->googleProps['div']=$div;
            $this->googleProps['width']=$width;
            $this->googleProps['height']=$height;
            $this->setup=true;
        }
        function scriptHead(){
            $script="";
            $script.="<script type=\"text/javascript\" >";
            $script.="document.write('<div class=\"map\" id=\"".$this->googleProps['div']."\" style=\"width:".$this->googleProps['width']."px;height:".$this->googleProps['height']."px;\"></div>');";
            $script.="window.onload(initMap".$this->googleProps['div']."());";
            $script.="function initMap".$this->googleProps['div']."(){
                        var myLatlng = new google.maps.LatLng('".$this->googleProps['center']->lat."','".$this->googleProps['center']->long."');
                        var myOptions = {
                          zoom: ".$this->googleProps['options']->zoom.",
                          center: myLatlng,
                          mapTypeId: google.maps.MapTypeId.".$this->googleProps['options']->mapTypeId->getType()."
                        };";
            $script.="var ".$this->googleProps['div']." = new google.maps.Map(document.getElementById('".$this->googleProps['div']."'),myOptions);";
            return $script;
        }
        function scriptFoot(){
            return "}</script>";
        }
        function script($eventsArray=array(),$markersArray=array()){
            GMAPI::getFile('GMAPI-overlays.php');
            GMAPI::getFile('GMAPI-base.php');
            $script=$this->scriptHead();
            if(!empty($markersArray)&& !is_null($markersArray)){
                foreach($markersArray as $key=>$marker){
                    $nmarker=new GMAPIMarker(new GMAPIMarkerOptions(new LatLng($marker['lat'],$marker['long']),$this->googleProps['div'],$marker['title'],true));
                    $script.=$nmarker->script($this->googleProps['div'],$key);
                    //$script.="map".$this->googleProps['div'].".".$nmarker->script($this->googleProps['div']);
                }

            }
            if(!empty ($eventsArray)&& !is_null($eventsArray)){
            GMAPI::getFile('GMAPI-events.php');
                foreach($eventsArray as $event){
                    $script.="map".$this->googleProps['div'].".".$event->script();
                }
            }
            //$script.="window.alert(".$this->googleProps['div'].".getCenter());";
            $script.=$this->scriptFoot();
            return $script;
        }
    }
}
if (!class_exists('MapOptions')) {
    class MapOptions extends GMAPIgoogleclass implements googleclass{
        public static $eventsArray=array();
        public static $methodsArray=array();
        public static $propertiesArray=array('center','mapTypeId','zoom');
        protected $googleProps=array('center'=> null,'mapTypeId'=>null,'zoom'=>1);
        protected $googleEvents=array();
        protected $googleMethods=array();
        //public static $propertiesArray=array('backgroundColor', 'center', 'disableDefaultUI', 'disableDoubleClickZoom', 'draggable', 'draggableCursor', 'draggingCursor', 'heading', 'keyboardShortcuts', 'mapTypeControl', 'mapTypeControlOptions', 'mapTypeId', 'maxZoom', 'minZoom', 'noClear', 'overviewMapControl', 'overviewMapControlOptions', 'panControl', 'panControlOptions', 'rotateControl', 'rotateControlOptions', 'scaleControl', 'scaleControlOptions', 'scrollwheel', 'streetView', 'streetViewControl', 'streetViewControlOptions', 'styles', 'tilt', 'zoom', 'zoomControl', 'zoomControlOptions');
        
        //private $mapOptionsArray = new array[31];//
/**
 * Creates a mapoptions object
 */
        function __construct($center=null,$id=null,$zoom=1){
            $this->init($center,$id,$zoom);
        }
        function init($center,$id,$zoom){
            $this->googleProps['center']=$center;
            $this->googleProps['zoom']=$zoom;
            $this->googleProps['mapTypeId']=$id;
            $this->setup=true;
        }
/**
 * returns a string of js to be used with a map object
 */
        function compileMapOptions(){
            $script="{";
            $script.="zoom:".$this->zoom;
            $script.="center:".$this->center;//$googleProps['center']->getLatlng();
            $script.="mapTypeId:".$this->mapTypeId;//$googleProps['mapTypeId']->getType();;
            $script.="}";
        }
        function script($name=""){
            return "Skeleton function";
        }
    }
}
if (!class_exists('MapTypeId')) {
    class MapTypeId {
        protected $MapTypeIdarray=array('type'=>'ROADMAP');
        private $id;
        function __construct($id){
            $this->id=strtoupper($id);
        }
        function getType(){
            return $this->id;
        }
    }
}
?>