<?php
/**
 * Documents the file following
 * @package googlemapsForWP
 * @author webcat
 */
//#################################################################
if (preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) {die('You are not allowed to call this page directly.');}
//#################################################################
if (!class_exists('gmfwpMap')) {
    /**
     * googlemapsForWP maps
     * The class provides access to
     */
    class gmfwpMap {
        protected static $sng = 0;
        protected static $MAP;
        protected static $maps = array();
        
        protected function __construct() {
            if(self::$sng ==0){
                throw new Exception();
            }            
        }
        static function getInstance($id, $args,$js='false') {
            if (self::$MAP == null) {
                self::$sng = 1;
                self::$MAP= new gmfwpMap();
            }
            if($js=='false'){
                return googlemapsForWPMap::getInstance($id, $args, $js);
            }else{
                return googlemapsForWPJSMap::getInstance($id, $args, $js);
            }
        }
    }
}
if (!class_exists('googlemapsForWPMap')) {
    /**
     * googlemapsForWP maps
     * The class provides access to
     */
    class googlemapsForWPMap extends gmfwpMap {

        protected static $URLlimit = 2048;
        protected static $HTTP = 'http://maps.googleapis.com/maps/api/staticmap?';
        protected static $HTTPS = 'https://maps.googleapis.com/maps/api/staticmap?';
        protected $url;
        protected $flags;
        protected $cacheexists;
        protected $cache;
        protected $ID;
        protected $mapParams;
        /**
         *
         * @param <type> $id
         * @param <type> $args
         */
        static function getInstance($id, $args,$js='false') {
            return new googlemapsForWPMap($id, $args,$js='false');
            //'mapname','mapdescription','longitude','latitude','zoom','sizewidth','sizeheight','type','format','sensor'
        }
        protected function __construct($id, $args,$js){
            parent::__construct();
            try {
                googlemapsForWP::getFile('business', 'googlemapsForWPMapImage.php');
                    if ( !file_exists($url . DIRECTORY_SEPARATOR . 'cache')) {
                    throw new Exception('no cache folder');
                    }
                    $this->cache = new googlemapsForWPMapImage();
                    $this->cacheexists = true;
                }catch (Exception $e) {
                $this->cacheexists = false;
                $this->cache = null;
            }
            $this->ID = $id;
            $this->mapParams = $args;
            $this->url = "";
            $this->flags = "";
        }
        /**
         * Creates a url of all the map's parameters urlencoded where necessary
         * @param string $security
         * @return string
         */
        function createURL($security) {
            switch ($security) {
                case '1':
                    $this->url = googlemapsForWPMap::$HTTP;
                    break;
                case '2':
                    $this->url = googlemapsForWPMap::$HTTPS;
                    break;
                default:
                    $this->url = googlemapsForWPMap::$HTTP;
                    break;
            }
            $params.='center=' . $this->mapParams['latitude'] . ',' . $this->mapParams['longitude'];
            $params.='&zoom=' . $this->mapParams['zoom'];
            $params.='&size=' . $this->mapParams['sizewidth'] . "x" . $this->mapParams['sizeheight'];
            $params.='&maptype=' . $this->mapParams['type'];
            $params.='&format=' . $this->mapParams['format'];
            $params.=$this->flags;
            $params.='&sensor=' . $this->mapParams['sensor'];
            $this->url.= $params;
            return $this->url;
        }
        /**
         * checks if an image has been cached for this map and if not <br /> returns the google request string
         */
        function getImage() {
            if (file_exists(googlemapsForWP::pluginDir() . 'cache' . DIRECTORY_SEPARATOR . 'map-' . $this->ID . '.' . $this->getExt($this->mapParams['format']))) {
                return googlemapsForWP::pluginURL() . 'cache/map-' . $this->ID . '.' . $this->getExt($this->mapParams['format']);
            } else {
                return $this->createURL(1);
            }
        }
        /**
         *
         * @param string google formatted
         * @return string clean extension
         */
        function getExt($f) {
            switch ($f) {
                case 'png8':
                    return 'png';
                    break;
                case 'png32':
                    return 'png';
                    break;
                case 'jpeg-baseline':
                    return 'jpg';
                    break;
                case 'jpeg':
                    return 'jpg';
                    break;
                case 'jpg-baseline':
                    return 'jpg';
                    break;
                case 'jpg':
                    return 'jpg';
                    break;
                case 'gif':
                    return 'gif';
                    break;
                default:
                    break;
            }
        }
        /**
         *
         * @param array $flags An array of the stored flags for this map
         */
        function addFlags($flags) {
            if (!empty($flags)) {
                $flagparams = "";
                foreach ($flags as $flag) {
                    $flagparams.= "&markers=size:" . $flag['size'] . urlencode('|') . "color:" . $flag['colour'] . urlencode('|') . "" . 'label:S' . urlencode('|') . $flag['latitude'] . "," . $flag['longitude'];
                }
                $this->flags = $flagparams;
            }
        }
        function getFlags() {
            if (isset($this->flags)) {
                return $this->flags;
            } else {
                return "";//changed to null from string
            }
        }
        function getShortCode() {
            $code = "<span>" . htmlentities("[getmap mapnumber='" . $this->ID . "']") . "</span>";
            return $code;
        }
        /**
         * @param <type> $paramname
         * @return <type>
         */
        function getID() {
            return $this->ID;
        }
        function getParam($paramname, $html=false) {
            if ($html) {
                return htmlentities($this->mapParams[$paramname]);
            } else {
                return $this->mapParams[$paramname];
            }
        }
    }
}
if (!class_exists('googlemapsForWPJSMap')) {
    /**
     * googlemapsForWP maps
     * The class provides access to
     */
    class googlemapsForWPJSMap extends googlemapsForWPMap {

        public static $HTTP = "http://maps.googleapis.com/maps/api/js?sensor=false";
        protected $ID;
        protected $mapParams;

        static function getInstance($id, $args,$js='true') {
            return new googlemapsForWPJSMap($id, $args,$js);
            //'mapname','mapdescription','longitude','latitude','zoom','sizewidth','sizeheight','type','format','sensor'
        }
        protected function __construct($id, $args,$js='true'){
            parent::__construct($id, $args,$js=true);
            try{
            googlemapsForWP::getFile('business'.DIRECTORY_SEPARATOR.'GMAPI', 'GMAPI.php');
            }catch(Exception $e){}
            $this->ID = $id;
            $this->mapParams = $args;
            }
        
        function compileMap($div,$markers=array()){
                    $markersarr=array();
            try{
                $gmapi = new GMAPI($div);
                $gmapimap=$gmapi->getMap('Map');
                if(sizeof($markers)>=1){
                    foreach($markers as $marker){
                        array_push($markersarr,array('lat'=>$marker['latitude'],'long'=>$marker['longitude'],'size'=>$marker['size'],'colour'=>$marker['colour'],'note'=>$marker['note'],'title'=>$marker['title']));
                    }
                }
                //get stored js features from db and add here
                $gmapimap->init($this->getParam('sizewidth'),$this->getParam('sizeheight'),$this->getParam('latitude'),$this->getParam('longitude'),$this->getParam('zoom'), strtoupper($this->getParam('type')));
                return $gmapimap->script($markersarr);
            }catch (Exception $e){return $e->getMessage();}
        }
        function switchJS(){
            $this->mapParams['js']='false';
            $newmap = gmfwpMap::getInstance($this->ID,$this->mapParams,$this->mapParams['js']);
            return $newmap;
        }
        /**
         * @param <type> $paramname
         * @return <type>
         */
        function getID() {
            return $this->ID;
        }
        function getParam($paramname, $html=false) {
            if ($html) {
                return htmlentities($this->mapParams[$paramname]);
            } else {
                return $this->mapParams[$paramname];
            }
        }
        
    }
}
?>