<?php
/**
 * Documents the file following
 * @package googlemapsForWP
 * @author webcat
 */
//#################################################################
if (preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) {
    die('You are not allowed to call this page directly.');
}
//#################################################################
if (!class_exists('googlemapsForWPAdminPage')) {

    /**
     * googlemapsForWP Admin Page
     * The class provides access to
     */
    class googlemapsForWPAdminPage {

        protected $googlemapsForWPMaps;
        protected $imageCache;

        function __construct() {
            if(get_option("googlemapsForWPversion") < googlemapsForWP::$googlemapsForWPVersion){googlemapsForWP::update();}
            add_action('wp_ajax_locationFinder', array($this, 'locationFinder'));
            add_action('wp_ajax_getMapPreview', array($this, 'getMapPreview'));
            add_action('wp_enqueue_scripts', array($this, 'scripts'));
            try{
                googlemapsForWP::getFile('business','googlemapsForWPMaps.php');
                googlemapsForWP::getFile('business','googlemapsForWPMapImage.php');
                    $this->imageCache = new googlemapsForWPMapImage();
                    $this->googlemapsForWPMaps = new googlemapsForWPMaps();
            }catch(Exception $e){
                throw $e;
            }
        }
        public function getmapPreview(){
            $map=$this->googlemapsForWPMaps->getMap($_POST['mapid']);
            echo $map->getParam('mapname')."<br /><img src='".$map->getImage(). "?". mktime()."' />";
            die();
        }
        public function locationFinder(){
            try{
                googlemapsForWP::getFile('business','geocodes.php');
                    $codes = new gmfwpGeoCodes();
                    if($location=="Postcode" || $location="" ){$location="";}$location=urldecode($_POST['location']);
                    if($address=="Address" || $address=""){$address="";}$address=urldecode($_POST['address']);
                    die($codes->getCodes($location,  $address));
            }catch(Exception $e){
                die("error");
            }
        }
        /**
         * Adds a menu page and item in the wordpress dashboard sidebar for display readme, acess submenus, feedback form for evaluation
         *
         */
        public function add_menu() {
            add_submenu_page('tools.php', 'googlemapsForWP Admin', 'googlemapsForWP', 'administrator', 'googlemapsForWPAdmin.php', array($this, 'output'));
            add_action('admin_enqueue_scripts', array($this, 'scripts'));
            add_action('admin_head', array($this, 'addHeadLinks'), 12);
            add_action('media_buttons', array($this, 'add_maps_select'), 11);
            add_action('admin_head', array($this, 'add_button_js'));
        }
        /**
         * Adds javascript to update posts with selected shortcode
         * Thanks to Kevin Chard for the tidy bit of shortcode code
         * @author Kevin Chard
         * @link http://wpsnipp.com/index.php/functions-php/update-automatically-create-media_buttons-for-shortcode-selection/
         */
        function add_button_js() { {
                echo '<script type="text/javascript">
                        jQuery(document).ready(function(){
                        jQuery("#map_select").change(function() {
                                var value=jQuery("#map_select :selected").val();
                                if(value != "Map Name"){
                                        send_to_editor(jQuery("#map_select :selected").val());
                                          return false;
                                      }
                                });
                        });
                    </script>';
                }
        }
        /**
         * Adds a shortcode selection to the WP editor
         * Thanks to Kevin Chard for the tidy bit of shortcode code
         * @author Kevin Chard
         * @link http://wpsnipp.com/index.php/functions-php/update-automatically-create-media_buttons-for-shortcode-selection/
         */
        function add_maps_select() {
            $maps = $this->googlemapsForWPMaps->getMaps();
            echo '<select id="map_select"><option>Map Name</option>';
            foreach ($maps as $key => $val) {
                if (!in_array($key, $exclude)) {
                    $shortcodes_list .= '<option value="'.$this->create_shortcode($val['id']).'">' . $val['mapname']  . '</option>';
                }
            }
            echo $shortcodes_list;
            echo '</select>';
        }

        function create_shortcode($mapid) {
            $code = htmlentities("[getmap mapnumber='" . $mapid . "']");
            return $code;
        }
        /**
         * Creates the page output.  Includes logic for selecting <br /> the correct screen
         * @uses googlemapsForWPMaps
         *
         */
        private function install(){
            try {
            googlemapsForWP::getFile('data', 'mapdata.php');
                $d = new googlemapsForWPDB();
                $d->install();
            } catch (Exception $e) {
                die($e->getMessage());
            }
        }
        private function uninstall(){
            try {
            googlemapsForWP::getFile('data', 'mapdata.php');
                $d = new googlemapsForWPDB();
                $d->uninstall();
            } catch (Exception $e) {
                die($e->getMessage());
            }
        }
        function input($data){
            $data = htmlspecialchars(stripslashes(trim($data)));
            return $data;
        }

        function handleMaps() {
            $heading = "Google Maps for WP Control Panel";
            $credits = googlemapsForWP::$googlemapsForWPCredits;
            $version = googlemapsForWP::$googlemapsForWPVersion;
            $tmpdir = googlemapsForWP::pluginDir() . 'output' . DIRECTORY_SEPARATOR;
            $mapname = $this->input($_POST['mapname']);
            $mapdescription = $this->input($_POST['mapdescription']);
            $long = $this->input($_POST['longitude']);
            $lat = $this->input($_POST['latitude']);
            $zoom = $this->input($_POST['zoom']);
            $width = $_POST['sizewidth'];
            $height = $_POST['sizeheight'];
            $type = $_POST['type'];
            $format = $this->input($_POST['format']);
            $js = $this->input($_POST['jsenabled']);
            $maps = $this->googlemapsForWPMaps->getMaps();
            $map = null;
            if (isset($_POST['savenew'])) {
                if (!empty($maps)) {
                    foreach ($maps as $value) {
                        if ($value['mapname'] == $mapname) {
                            $mapname = $mapname . "-1";
                        }
                    }
                }
                try {
                    $map = $this->googlemapsForWPMaps->addMap(array('mapname' => $mapname, 'mapdescription' => $mapdescription, 'longitude' => $long, 'latitude' => $lat, 'zoom' => $zoom, 'sizewidth' => $width, 'sizeheight' => $height, 'type' => $type, 'format' => $format, 'sensor' => 'false', 'js' => $js));
                    $this->imageCache->storeImage($map);
                } catch (Exception $e) {
                    $status = $this->googlemapsForWPMaps->getStatus();
                    include_once $tmpdir . 'googlemapsForWPerrorscreen.tpl';
                    return;
                }
            }
            if (isset($_POST['saveupdated'])) {
                try {
                    $mapid = stripslashes($_POST['map']);
                    $map = $this->googlemapsForWPMaps->updateMap($mapid, array('mapname' => $mapname, 'mapdescription' => $mapdescription, 'longitude' => $long, 'latitude' => $lat, 'zoom' => $zoom, 'sizewidth' => $width, 'sizeheight' => $height, 'type' => $type, 'format' => $format, 'sensor' => 'false', 'js' => $js));
                    $this->imageCache->storeImage($map);
                } catch (Exception $e) {
                    $status = $this->googlemapsForWPMaps->getStatus();
                    include_once $tmpdir . 'googlemapsForWPerrorscreen.tpl';
                    return;
                }
            }
            $heading = "Add and Delete Flags";
            $flags = $this->googlemapsForWPMaps->getFlags($map->getID());
            include_once $tmpdir . 'googlemapsForWPflagscreen.tpl';
            return;
        }
        function handleFlags(){
            $heading = "Google Maps for WP Control Panel";
            $credits = googlemapsForWP::$googlemapsForWPCredits;
            $version = googlemapsForWP::$googlemapsForWPVersion;
            $tmpdir = googlemapsForWP::pluginDir() . 'output'. DIRECTORY_SEPARATOR ;
            $mapid = stripslashes(intval($_POST['mapid']));
                $map = $this->googlemapsForWPMaps->getMap($mapid);
                if (!$map == false) {
                    $map->addFlags($this->googlemapsForWPMaps->getFlags($mapid));
                }
                $flags=$this->googlemapsForWPMaps->getFlags($mapid);
            if(isset($_POST['addflags'])){
                include_once $tmpdir . 'googlemapsForWPflagscreen.tpl';
                return;
            }
            if(isset($_POST['newflag'])||isset($_POST['saveupdatedflag'])){
                $args = array('longitude' => stripslashes($_POST['longitude']), 'latitude' => stripslashes($_POST['latitude']), 'map' => $mapid, 'type' => 'flag', 'size' => stripslashes($_POST['flagsize']), 'colour' => stripslashes($_POST['flagcolour']), 'note' => $this->input($_POST['note']), 'title' => $this->input($_POST['title']));
                if(isset($_POST['newflag'])){$isadded = $this->googlemapsForWPMaps->addFlag($args);}
                else{$isadded = $this->googlemapsForWPMaps->updateFlag($_POST['flagid'],$args);}
                $map = $this->googlemapsForWPMaps->getMap(intval($mapid));
                if ($isadded && !($map == false)) {
                    $flags = $this->googlemapsForWPMaps->getFlags($mapid);
                    $map->addFlags($flags);
                    try{
                        $this->imageCache->storeImage($map);
                        }catch(Exception $e){
                            $status = $this->googlemapsForWPMaps->getStatus();
                            include_once $tmpdir . 'googlemapsForWPerrorscreen.tpl';
                            return;
                        }
                    include_once $tmpdir . 'googlemapsForWPflagscreen.tpl';
                    return;
                } else {
                    $status = $this->googlemapsForWPMaps->getStatus();
                    include_once $tmpdir . 'googlemapsForWPerrorscreen.tpl';
                    return;
                }
            }else{
                if (isset($_POST['editflagid'])) {
                    $flagid = $_POST['editflagid'];
                            $mapid = stripslashes(intval($_POST['editmapid']));
                            //$mapid = stripslashes($_POST['map']);
                            //$this->googlemapsForWPMaps->deleteFlag($flagid);
                            $map = $this->googlemapsForWPMaps->getMap($mapid);
                            if (!$map == false) {
                                $flags = $this->googlemapsForWPMaps->getFlags($mapid);
                                $flag=null;
                                foreach($flags as $v){
                                    if($v['id']==$flagid){
                                        $flag=$v;
                                    }
                                }
                                $this->imageCache->storeImage($map);
                                include_once $tmpdir . 'googlemapsForWPeditflagscreen.tpl';
                            } else {
                            $status = $this->googlemapsForWPMaps->getStatus();
                            include_once $tmpdir . 'googlemapsForWPerrorscreen.tpl';
                            return;
                        }
                    }else{
                    $flagid = $_POST['deleteflagid'];
                        $mapid = stripslashes(intval($_POST['deletemapid']));
                        $map = null;
                        //$mapid = stripslashes($_POST['map']);
                        $this->googlemapsForWPMaps->deleteFlag($flagid);
                        $map = $this->googlemapsForWPMaps->getMap($mapid);
                        if (!$map == false) {
                            $flags = $this->googlemapsForWPMaps->getFlags($mapid);
                            $this->imageCache->storeImage($map);
                            include_once $tmpdir . 'googlemapsForWPflagscreen.tpl';
                            return;
                        } else {
                            $status = $this->googlemapsForWPMaps->getStatus();
                            include_once $tmpdir . 'googlemapsForWPerrorscreen.tpl';
                            return;
                        }
                    }
            }
        }
        function output(){
            $heading = "Google Maps for WP Control Panel";
            $credits = googlemapsForWP::$googlemapsForWPCredits;
            $version = googlemapsForWP::$googlemapsForWPVersion;
            $tmpdir = googlemapsForWP::pluginDir() . 'output' . DIRECTORY_SEPARATOR;
            if (isset($_POST['deletemap'])) {
                $mapid = stripslashes($_POST['selectedmapid']);
                $this->googlemapsForWPMaps->deleteMap($mapid);
                $this->imageCache->deleteImage($mapid);
                $maps = $this->googlemapsForWPMaps->getMaps();
                include_once $tmpdir . 'googlemapsForWPadminscreen.tpl';
                return;
            }
            if (isset($_POST['addmap']) || isset($_POST['editmap'])) {
                if (isset($_POST['editmap'])) {
                    $mapid = stripslashes($_POST['selectedmapid']);
                    $map = $this->googlemapsForWPMaps->getMap(intval($mapid));
                    if (!$map == false) {
                        $map->addFlags($this->googlemapsForWPMaps->getFlags($mapid));
                        include_once $tmpdir . 'googlemapsForWPeditmapscreen.tpl';
                        return;
                    } else {
                        $status = $this->googlemapsForWPMaps->getStatus();
                        include_once $tmpdir . 'googlemapsForWPerrorscreen.tpl';
                        return;
                    }
                } else {
                    include_once $tmpdir . 'googlemapsForWPaddmapscreen.tpl';
                    return;
                }
            }
            if(isset($_POST['savenew']) && $_POST['savenew'] == 'true' || isset($_POST['saveupdated']) && $_POST['saveupdated'] == 'true'){
                 $this->handleMaps();return;
            }
            if (isset($_POST['deleteflagid'])||isset($_POST['newflag'])||isset($_POST['saveupdatedflag'])||isset($_POST['editflagid'])||isset($_POST['addflags'])) {
                $this->handleFlags();return;
            }
            $maps = $this->googlemapsForWPMaps->getMaps();
            include_once $tmpdir . 'googlemapsForWPadminscreen.tpl';
            return;
        }
        /*
         * Calls the wordpress script loader to make sure it's available when the scripts run
         */
        function scripts() {
          wp_enqueue_script(array("tw-sack"));
            wp_register_script( 'jquery1-6', googlemapsForWP::pluginURL()."js/jQuery1-6.js");
            wp_register_script( 'googlemapsForWP', googlemapsForWP::pluginURL()."js/googlemapsForWP.js");
            wp_enqueue_script('jQuery1-6', googlemapsForWP::pluginURL()."js/jQuery1-6.js", array('jQuery'), '1.6');
            wp_enqueue_script('googlemapsForWP', googlemapsForWP::pluginURL()."js/googlemapsForWP.js", array('jQuery1-6'), googlemapsForWP::$googlemapsForWPVersion);
            try{
            googlemapsForWP::getFile('ui', 'googlemapsForWPMap.php');
            }catch(Exception $e){}
            wp_register_script( 'googlemapsAPI', googlemapsForWPJSMap::$HTTP);
            wp_enqueue_script('googlemapsAPI', googlemapsForWPJSMap::$HTTP);
            
        }
        /*
         *
         * Adds js and stylesheet to header
         */
        function addHeadLinks() {
            echo '<link rel="stylesheet" type="text/css" href="' . googlemapsForWP::pluginURL() . 'googlemapsForWPstyles.css" />';
            //echo '<script type="text/javascript" src="' . googlemapsForWP::pluginURL() . 'js/admin.js" ></script>';
        }
    }
}
?>